﻿using System;
using Microsoft.IdentityModel.Clients.ActiveDirectory;
using UIKit;

namespace EwsOAuthTest
{
    public partial class ViewController : UIViewController
    {
        public ViewController(IntPtr handle) : base(handle)
        {
        }
        
        public override void ViewDidAppear(bool animated)
        {
            base.ViewDidAppear(animated);

            // Run the authentication process after the view has been displayed, doing it before will not work
            AuthenticateWithEWS();
        }

        private async void AuthenticateWithEWS()
        {
            try
            {
                var platformParameters = new PlatformParameters(this, false);
                var ac = new AuthenticationContext("https://login.microsoftonline.com/common");
                
                // Display the login dialog, this will be displayed only the first time, after that it just returns the existing token without displaying a view
                var ar = await ac.AcquireTokenAsync(
                   "https://outlook.office365.com/",
                   "the_client_id_we_get_from_azure",
                   new Uri("http://www.the_app_url.com/"),
                   platformParameters);

                var result = ar.AccessToken;
                var expirationDate = ar.ExpiresOn;
                // Save the token somewhere, it will continue to work until it expires
            }
            catch (Exception ex)
            {
                return;
            }
        }
    }
}